]> arthur.barton.de Git - netdata.git/blob - plugins.d/charts.d.plugin
added apache mod_status monitoring
[netdata.git] / plugins.d / charts.d.plugin
1 #!/bin/bash
2
3 PROGRAM_FILE="$0"
4 PROGRAM_NAME="$(basename $0)"
5 PROGRAM_NAME="${PROGRAM_NAME/.plugin}"
6
7 # if you need to run parallel charts.d processes
8 # just link this files with a different name
9 # in the same directory, with a .plugin suffix
10 # netdata will start multiple of them
11 # each will have a different config file
12
13 echo >&2 "$PROGRAM_NAME: started from '$PROGRAM_FILE' with options: $*"
14
15 if [ $(( ${BASH_VERSINFO[0]} )) -lt 4 ]
16 then
17         echo >&2
18         echo >&2 "$PROGRAM_NAME: ERROR"
19         echo >&2 "BASH version 4 or later is required."
20         echo >&2 "You are running version: ${BASH_VERSION}"
21         echo >&2 "Please upgrade."
22         echo >&2
23         exit 1
24 fi
25
26 # check a few commands
27 require_cmd() {
28         which "$1" >/dev/null
29         if [ $? -ne 0 ]
30                 then
31                 echo >&2 "$PROGRAM_NAME: ERROR: Command '$1' is not found in the system path."
32                 return 1
33         fi
34         return 0
35 }
36
37 require_cmd date || exit 1
38 require_cmd sed || exit 1
39 require_cmd basename || exit 1
40 require_cmd dirname || exit 1
41 require_cmd cat || exit 1
42 require_cmd grep || exit 1
43 require_cmd egrep || exit 1
44 require_cmd mktemp || exit 1
45 require_cmd awk || exit 1
46
47 # -----------------------------------------------------------------------------
48 # insternal defaults
49 # netdata exposes a few environment variables for us
50
51 pause_method="sleep" # use either "suspend" or "sleep"
52                      # DO NOT USE SUSPEND - LINUX WILL SUSPEND NETDATA TOO
53                      # THE WHOLE PROCESS GROUP - NOT JUST THE SHELL
54
55 pluginsd="${NETDATA_PLUGINS_DIR}"
56 [ -z "$pluginsd" ] && pluginsd="$( dirname $PROGRAM_FILE )"
57
58 confd="${NETDATA_CONFIG_DIR-/etc/netdata}"
59 chartsd="$pluginsd/../charts.d"
60
61 myconfig="$confd/$PROGRAM_NAME.conf"
62
63 minimum_update_frequency="${NETDATA_UPDATE_EVERY-1}"
64 update_every=${minimum_update_frequency}        # this will be overwritten by the command line
65
66 # work around for non BASH shells
67 charts_create="_create"
68 charts_update="_update"
69 charts_check="_check"
70 charts_undescore="_"
71
72 # when making iterations, charts.d can loop more frequently
73 # to prevent plugins missing iterations.
74 # this is a percentage relative to update_every to align its
75 # iterations.
76 # The minimum is 10%, the maximum 100%.
77 # So, if update_every is 1 second and time_divisor is 50,
78 # charts.d will iterate every 500ms.
79 # Charts will be called to collect data only if the time
80 # passes since the last time the collected data is equal or
81 # above their update_every.
82 time_divisor=50
83
84 # number of seconds to run without restart
85 # after this time, charts.d.plugin will exit
86 # netdata will restart it
87 restart_timeout=1800
88
89 # check if the charts.d plugins are using global variables
90 # they should not.
91 # It does not currently support BASH v4 arrays, so it is
92 # disabled
93 dryrunner=0
94
95 # check for timeout command
96 check_for_timeout=1
97
98 # the default enable/disable value for all charts
99 enable_all_charts="yes"
100
101 # -----------------------------------------------------------------------------
102 # parse parameters
103
104 debug=0
105 check=0
106 chart_only=
107 while [ ! -z "$1" ]
108 do
109         if [ "$1" = "check" ]
110         then
111                 check=1
112                 shift
113                 continue
114         fi
115
116         if [ "$1" = "debug" -o "$1" = "all" ]
117         then
118                 debug=1
119                 shift
120                 continue
121         fi
122
123         if [ -f "$chartsd/$1.chart.sh" ]
124         then
125                 debug=1
126                 chart_only="$( echo $1.chart.sh | sed "s/\.chart\.sh$//g" )"
127                 shift
128                 continue
129         fi
130
131         if [ -f "$chartsd/$1" ]
132         then
133                 debug=1
134                 chart_only="$( echo $1 | sed "s/\.chart\.sh$//g" )"
135                 shift
136                 continue
137         fi
138
139         # number check
140         n="$1"
141         x=$(( n ))
142         if [ "$x" = "$n" ]
143         then
144                 shift
145                 update_every=$x
146                 [ $update_every -lt $minimum_update_frequency ] && update_every=$minimum_update_frequency
147                 continue
148         fi
149
150         echo >&2 "Cannot understand parameter $1. Aborting."
151         echo "DISABLE"
152         exit 1
153 done
154
155
156 # -----------------------------------------------------------------------------
157 # load my configuration
158
159 if [ -f "$myconfig" ]
160         then
161         . "$myconfig"
162         if [ $? -ne 0 ]
163         then
164                 echo >&2 "$PROGRAM_NAME: cannot load $myconfig"
165                 echo "DISABLE"
166                 exit 1
167         fi
168         time_divisor=$((time_divisor))
169         [ $time_divisor -lt 10 ] && time_divisor=10
170         [ $time_divisor -gt 100 ] && time_divisor=100
171 else
172         echo >&2 "$PROGRAM_NAME: configuration file '$myconfig' not found. Using defaults."
173 fi
174
175 if [ "$pause_method" = "suspend" ]
176 then
177         # enable bash job control
178         # this is required for suspend to work
179         set -m
180 fi
181
182 # we check for the timeout command, after we load our
183 # configuration, so that the user may overwrite the
184 # timeout command we use, providing a function that
185 # can emulate the timeout command we need:
186 # > timeout SECONDS command ...
187 if [ $check_for_timeout -eq 1 ]
188         then
189         require_cmd timeout || exit 1
190 fi
191
192 # -----------------------------------------------------------------------------
193 # internal checks
194
195 # netdata passes the requested update frequency as the first argument
196 update_every=$(( update_every + 1 - 1)) # makes sure it is a number
197 test $update_every -eq 0 && update_every=1 # if it is zero, make it 1
198
199 # check the charts.d directory
200 if [ ! -d "$chartsd" ]
201         then
202         echo >&2 "$PROGRAM_NAME: cannot find charts directory '$chartsd'"
203         echo "DISABLE"
204 fi
205
206
207 # -----------------------------------------------------------------------------
208 # loop control
209
210 # default sleep function
211 LOOPSLEEPMS_HIGHRES=0
212 loopsleepms() {
213         [ "$1" = "tellwork" ] && shift
214         sleep $1
215 }
216
217 now_ms=
218 current_time_ms() {
219         now_ms="$(date +'%s')000"
220 }
221
222 # if found and included, this file overwrites loopsleepms()
223 # and current_time_ms() with a high resolution timer function
224 # for precise looping.
225 . "$pluginsd/loopsleepms.sh.inc"
226
227
228 # -----------------------------------------------------------------------------
229 # library functions
230
231 fixid() {
232         echo "$*" |\
233                 tr -c "[A-Z][a-z][0-9]" "_" |\
234                 sed -e "s|^_\+||g" -e "s|_\+$||g" -e "s|_\+|_|g" |\
235                 tr "[A-Z]" "[a-z]"
236 }
237
238 # convert any floating point number
239 # to integer, give a multiplier
240 # the result is stored in ${FLOAT2INT_RESULT}
241 # so that no fork is necessary
242 float2int() {
243         local f="$1" m="$2" a b l
244
245         # echo >&2 "f='${f}', m='${m}'"
246
247         # split the floating point number
248         # in integer (a) and decimal (b)
249         a=${f/.*/}
250         b=${f/*./}
251
252         # the length of the multiplier
253         l=$[ ${#m} - 1 ]
254
255         # cut the decimal part if it is
256         # longer than the multiplier
257         [ ${#b} -gt ${l} ] && b=${b:0:${l}}
258         b=$[10#$b]
259
260         # prepend a zero to the integer
261         # part, if it is missing
262         [ -z "${a}" ] && a="0"
263         a=$[10#$a]
264
265         # store the result
266         FLOAT2INT_RESULT=$[ (a * m) + b ]
267         # echo >&2 "FLOAT2INT_RESULT='${FLOAT2INT_RESULT}'"
268 }
269
270
271 # -----------------------------------------------------------------------------
272 # charts check functions
273
274 all_charts() {
275         cd "$chartsd"
276         [ $? -ne 0 ] && echo >&2 "$PROGRAM_NAME: Cannot cd to $chartsd" && return 1
277
278         ls *.chart.sh | sed "s/\.chart\.sh$//g"
279 }
280
281 all_enabled_charts() {
282         local charts= enabled=
283
284         # find all enabled charts
285
286         for chart in $( all_charts )
287         do
288                 eval "enabled=\$$chart"
289                 if [ -z "${enabled}" ]
290                         then
291                         enabled="${enable_all_charts}"
292                 fi
293
294                 if [ ! "${enabled}" = "yes" ]
295                 then
296                         echo >&2 "$PROGRAM_NAME: '$chart' is NOT enabled. Add a line with $chart=yes in $myconfig to enable it (or remove the line that disables it)."
297                 else
298                         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' is enabled."
299                         local charts="$charts $chart"
300                 fi
301         done
302
303         local charts2=
304         for chart in $charts
305         do
306                 # check the enabled charts
307                 local check="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_check()" )"
308                 if [ -z "$check" ]
309                 then
310                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_check() function. Disabling it."
311                         continue
312                 fi
313
314                 local create="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_create()" )"
315                 if [ -z "$create" ]
316                 then
317                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_create() function. Disabling it."
318                         continue
319                 fi
320
321                 local update="$( cat "$chartsd/$chart.chart.sh" | sed "s/^ \+//g" | grep "^$chart$charts_update()" )"
322                 if [ -z "$update" ]
323                 then
324                         echo >&2 "$PROGRAM_NAME: chart '$chart' does not seem to have a $chart$charts_update() function. Disabling it."
325                         continue
326                 fi
327
328                 # check its config
329                 #if [ -f "$confd/$chart.conf" ]
330                 #then
331                 #       if [ ! -z "$( cat "$confd/$chart.conf" | sed "s/^ \+//g" | grep -v "^$" | grep -v "^#" | grep -v "^$chart$charts_undescore" )" ]
332                 #       then
333                 #               echo >&2 "$PROGRAM_NAME: chart's $chart config $confd/$chart.conf should only have lines starting with $chart$charts_undescore . Disabling it."
334                 #               continue
335                 #       fi
336                 #fi
337
338                 #if [ $dryrunner -eq 1 ]
339                 #       then
340                 #       "$pluginsd/charts.d.dryrun-helper.sh" "$chart" "$chartsd/$chart.chart.sh" "$confd/$chart.conf" >/dev/null
341                 #       if [ $? -ne 0 ]
342                 #       then
343                 #               echo >&2 "$PROGRAM_NAME: chart's $chart did not pass the dry run check. This means it uses global variables not starting with $chart. Disabling it."
344                 #               continue
345                 #       fi
346                 #fi
347
348                 local charts2="$charts2 $chart"
349         done
350
351         echo $charts2
352         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: enabled charts: $charts2"
353 }
354
355
356 # -----------------------------------------------------------------------------
357 # load the charts
358
359 suffix_update_every="_update_every"
360 active_charts=
361 for chart in $( all_enabled_charts )
362 do
363         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: loading chart: '$chartsd/$chart.chart.sh'"
364         . "$chartsd/$chart.chart.sh"
365
366         if [ -f "$confd/$chart.conf" ]
367         then
368                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: loading chart options: '$confd/$chart.conf'"
369                 . "$confd/$chart.conf"
370         else
371                 echo >&2 "$PROGRAM_NAME: $chart: configuration file '$confd/$chart.conf' not found. Using defaults."
372         fi
373
374         eval "dt=\$$chart$suffix_update_every"
375         dt=$(( dt + 1 - 1 )) # make sure it is a number
376         if [ $dt -lt $update_every ]
377         then
378                 eval "$chart$suffix_update_every=$update_every"
379         fi
380
381         $chart$charts_check
382         if [ $? -eq 0 ]
383         then
384                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' activated"
385                 active_charts="$active_charts $chart"
386         else
387                 echo >&2 "$PROGRAM_NAME: chart '$chart' check() function reports failure."
388         fi
389 done
390 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: activated charts: $active_charts"
391
392
393 # -----------------------------------------------------------------------------
394 # check overwrites
395
396 # enable work time reporting
397 debug_time=
398 test $debug -eq 1 && debug_time=tellwork
399
400 # if we only need a specific chart, remove all the others
401 if [ ! -z "${chart_only}" ]
402 then
403         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: requested to run only for: '${chart_only}'"
404         check_charts=
405         for chart in $active_charts
406         do
407                 if [ "$chart" = "$chart_only" ]
408                 then
409                         check_charts="$chart"
410                         break
411                 fi
412         done
413         active_charts="$check_charts"
414 fi
415 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: activated charts: $active_charts"
416
417 # stop if we just need a pre-check
418 if [ $check -eq 1 ]
419 then
420         echo >&2 "CHECK RESULT"
421         echo >&2 "Will run the charts: $active_charts"
422         exit 0
423 fi
424
425 # -----------------------------------------------------------------------------
426 # create temp dir
427
428 TMP_DIR=
429 chartsd_cleanup() {
430         cd /tmp
431         if [ ! -z "$TMP_DIR" -a -d "$TMP_DIR" ]
432         then
433                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: cleaning up temporary directory $TMP_DIR ..."
434                 rm -rf "$TMP_DIR"
435         fi
436         exit 0
437 }
438 trap chartsd_cleanup EXIT
439 trap chartsd_cleanup SIGHUP
440 trap chartsd_cleanup INT
441
442 if [ $UID = "0" ]
443 then
444         TMP_DIR="$( mktemp -d /var/run/netdata-${PROGRAM_NAME}-XXXXXXXXXX )"
445 else
446         TMP_DIR="$( mktemp -d /tmp/.netdata-${PROGRAM_NAME}-XXXXXXXXXX )"
447 fi
448
449 cd "$TMP_DIR" || exit 1
450
451 # -----------------------------------------------------------------------------
452 # create charts
453
454 run_charts=
455 for chart in $active_charts
456 do
457         [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: Calling '$chart$charts_create()'..."
458         $chart$charts_create
459         if [ $? -eq 0 ]
460         then
461                 run_charts="$run_charts $chart"
462                 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: '$chart' has initialized."
463         else
464                 echo >&2 "$PROGRAM_NAME: chart '$chart' function '$chart$charts_create()' reports failure."
465         fi
466 done
467 [ $debug -eq 1 ] && echo >&2 "$PROGRAM_NAME: run_charts='$run_charts'"
468
469
470 # -----------------------------------------------------------------------------
471 # update dimensions
472
473 if [ -z "$run_charts" ]
474         then
475         echo >&2 "$PROGRAM_NAME: No charts to collect data from."
476         echo "DISABLE"
477         exit 1
478 fi
479
480 declare -A charts_last_update=() charts_update_every=() charts_next_update=() charts_run_counter=()
481 global_update() {
482         local exit_at \
483                 c=0 dt ret last_ms exec_start_ms exec_end_ms \
484                 chart now_charts=() next_charts=($run_charts)
485
486         # return the current time in ms in $now_ms
487         current_time_ms
488
489         exit_at=$(( now_ms + (restart_timeout * 1000) ))
490
491         for chart in $run_charts
492         do
493                 eval "charts_update_every[$chart]=\$$chart$suffix_update_every"
494                 test -z "${charts_update_every[$chart]}" && charts_update_every[$charts]=$update_every
495                 charts_last_update[$chart]=$((now_ms - (now_ms % (charts_update_every[$chart] * 1000) ) ))
496                 charts_next_update[$chart]=$(( charts_last_update[$chart] + (charts_update_every[$chart] * 1000) ))
497                 charts_run_counter[$chart]=0
498
499                 echo "CHART netdata.plugin_chartsd_$chart '' 'Execution time for $chart plugin' 'milliseconds / run' netdata netdata area 90000 ${charts_update_every[$chart]}"
500                 echo "DIMENSION run_time 'run time' absolute 1 1"
501         done
502
503         # the main loop
504         while [ 1 ]
505         do
506                 c=$((c + 1))
507                 now_charts=("${next_charts[@]}")
508                 next_charts=()
509
510                 # return the current time in ms in $now_ms
511                 current_time_ms
512
513                 for chart in "${now_charts[@]}"
514                 do
515                         # echo >&2 "DEBUG: chart: $chart last: ${charts_last_update[$chart]}, next: ${charts_next_update[$chart]}, now: ${now_ms}"
516                         if [ ${now_ms} -ge ${charts_next_update[$chart]} ]
517                         then
518                                 last_ms=${charts_last_update[$chart]}
519                                 dt=$(( (now_ms - last_ms) ))
520                                 # echo >&2 "DEBUG: chart: $chart last: ${charts_last_update[$chart]}, next: ${charts_next_update[$chart]}, now: ${now_ms}, dt: ${dt}"
521
522                                 charts_last_update[$chart]=${now_ms}
523
524                                 while [ ${charts_next_update[$chart]} -lt ${now_ms} ]
525                                 do
526                                         charts_next_update[$chart]=$(( charts_next_update[$chart] + (charts_update_every[$chart] * 1000) ))
527                                 done
528
529                                 # the first call should not give a duration
530                                 # so that netdata calibrates to current time
531                                 dt=$(( dt * 1000 ))
532                                 charts_run_counter[$chart]=$(( charts_run_counter[$chart] + 1 ))
533                                 if [ ${charts_run_counter[$chart]} -eq 1 ]
534                                         then
535                                         dt=
536                                 fi
537
538                                 exec_start_ms=$now_ms
539                                 $chart$charts_update $dt
540                                 ret=$?
541                                 
542                                 # return the current time in ms in $now_ms
543                                 current_time_ms; exec_end_ms=$now_ms
544
545                                 echo "BEGIN netdata.plugin_chartsd_$chart $dt"
546                                 if [ $ret -eq 0 ]
547                                 then
548                                         echo "SET run_time = $(( exec_end_ms - exec_start_ms ))"
549                                         next_charts+=($chart)
550                                 else
551                                         echo "SET run_time = $(( (exec_end_ms - exec_start_ms) * -1 ))"
552                                         echo >&2 "$PROGRAM_NAME: chart '$chart' update() function reports failure. Disabling it."
553                                 fi
554                                 echo "END"
555                         else
556                                 next_charts+=($chart)
557                         fi
558                 done
559
560                 if [ "$pause_method" = "suspend" ]
561                 then
562                         echo "STOPPING_WAKE_ME_UP_PLEASE"
563                         suspend || ( echo >&2 "$PROGRAM_NAME: suspend returned error $?, falling back to sleep."; loopsleepms $debug_time $update_every $time_divisor)
564                 else
565                         # wait the time you are required to
566                         #loopsleepms $debug_time $update_every $time_divisor
567                         if [ ${LOOPSLEEPMS_HIGHRES} -eq 1 ]
568                                 then
569                                 sleep 0.2
570                         else
571                                 sleep 1
572                         fi
573                 fi
574
575                 test ${now_ms} -ge ${exit_at} && exit 0
576         done
577 }
578
579 global_update